/* 
    jgaadb - is a simple C++ class library for ODBC databases.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/

#ifndef DB_COLUMN_DEF_H
#define DB_COLUMN_DEF_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/
BEGIN_JGAADB_NAMESPACE

#ifdef __cplusplus

class DbColumnDef 
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    DbColumnDef(db_c_str_t colName = NULL, 
        int sqlType = 0, 
        bool isNullable = false, 
        size_t mSize = 0, 
        size_t mDigits = 0);
    
    /**
    * Copy constructor.
    *
    * @param from The value to copy to this object.
    */
    DbColumnDef(const DbColumnDef& from);
    
    /**
    * Destructor.
    */
    ~DbColumnDef();
    
    // OPERATORS
    
    /**
    * Assignment operator.
    *
    * @param from THe value to assign to this object.
    *
    * @return A reference to this object.
    */
    DbColumnDef& operator = (const DbColumnDef& from);
    
    // OPERATIONS
    // CALLBACK
    // ACCESS
    // INQUIRY
    std::string mName;
    int mSqlType;
    bool mIsNullable;
    size_t mSize; // Max [valid] size
    size_t mDigits;
    std::string mDefaultValue;
protected:
private:
};

typedef std::list<DbColumnDef> fieldlist_t;

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

END_JGAADB_NAMESPACE

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* DB_COLUMN_DEF_H_ */

