/* 
    jgaadb - is a simple C++ class library for ODBC databases.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/


#ifndef JGAADB_DB_COMMAND_H
#define JGAADB_DB_COMMAND_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

BEGIN_JGAADB_NAMESPACE


#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class DbCommand 
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    DbCommand(DbConnection& conn);
     
    /**
    * Destructor.
    */
    virtual ~DbCommand();
    
    // OPERATORS  
    // OPERATIONS

    void Bind(DbColumn *pCol) throw(std::exception);
    void Execute(const char *query, 
        DbRecordset *pResultset = NULL)
        throw(std::exception);
    void PrepareStatement(const char *query)
        throw(std::exception);
    void ExecutePrepared(DbRecordset *pResultset = NULL)
        throw(std::exception);

    void Close();
    void Reset() throw(std::exception);
    void ResetArguments();

    void EnumTables(db_table_list_t& tables)
        throw(std::exception);
    void SetTimeout(SQLUINTEGER newTimeout);

    void SetDebugMode(bool enableDebug);

    // CALLBACK
    // ACCESS

    SQLHSTMT GetHtsmt();
    DbConnection &GetConn();

    // INQUIRY
    long GetAffectedRows() const;

    static int msDefaultTimeout; // Timeout in second. 0 = no timeout
protected:
    bool mIsVirgin;

    void AllocHstmt() throw(DbException);

private:
    DbConnection& mConn;
    SQLHSTMT mHstmt;
    SQLINTEGER mAffectedRows;
    int mParamIndex; // Used to bind arguments
    SQLUINTEGER mTimeout; // Timeout in second. 0 = no timeout
    bool mDebugFlag;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

END_JGAADB_NAMESPACE

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* JGAADB_DB_COMMAND_H_ */

