/* 
    jgaadb - is a simple C++ class library for ODBC databases.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/

#ifndef JGAADB_JGAADB_DBEXCEPTION_H
#define JGAADB_DBEXCEPTION_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

BEGIN_JGAADB_NAMESPACE

class DbConnection;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class DbException :
public jgaadb::DbBasicException
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    DbException(DbConnection *pconn,
        int handleType, 
        SQLHANDLE handle,
        const char *moduleName,
        const char *explanation,
        const char *query,
        int line,
        const char *fileName);
        
    /**
    * Destructor.
    */
    ~DbException();
    
    // OPERATORS    
    // OPERATIONS
    // CALLBACK
    // ACCESS
    // INQUIRY

	void GetSqlState(std::string& state) const;
	SQLINTEGER GetSqlNativeError() const;
    
protected:
    SQLINTEGER mSqlNativeError;
    SQLCHAR mSqlState[16];

private:
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#define ThrowDb(conn, htype, handle, mname, expl, query) \
    throw DbException(conn, htype, handle, mname, expl, query, __LINE__, __FILE__)

END_JGAADB_NAMESPACE

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* JGAADB_DBEXCEPTION_H_ */

