/* 
    jgaadb - is a simple C++ class library for ODBC databases.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/

#ifndef DB_RECORDSET_H
#define DB_RECORDSET_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

BEGIN_JGAADB_NAMESPACE

class DbCommand;

#ifdef __cplusplus

class DbRecordset 
{
public:
    typedef std::vector<DbColumn *> columns_t;

    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    DbRecordset(DbCommand *pCommand = NULL);
    
    /**
    * Destructor.
    */
    virtual ~DbRecordset();
    
    // OPERATORS

    DbColumn& operator [] (unsigned index) throw (DbException);

    // OPERATIONS

    void MoveNext() throw(std::exception);
    void Reset();

    // Fetch after a SQL* function creating a recordset
    void FetchFirst() throw(std::exception);

    // CALLBACK
    // ACCESS
    // INQUIRY

    bool IsEof() const;
    size_t GetNumColumns() const;
    
protected:
    void FetchNext() throw(std::exception);
    void KillColumns();
    static void ResetCache(DbColumn *pCol);

private:
    friend class DbCommand;
    columns_t mColumns;
    DbCommand *mpCommand;
    bool mIsEof;
	bool mMustCloseCursor;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */


END_JGAADB_NAMESPACE

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* DB_RECORDSET_H_ */

