/* 
    jgaadb - is a simple C++ class library for ODBC databases.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/

#ifndef JGAADB_DB_TABLELIST_H
#define JGAADB_DB_TABLELIST_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

BEGIN_JGAADB_NAMESPACE


#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class DbTable 
{
public:
    // LIFECYCLE
    
    DbTable(const char *name,
        const char *schema,
        const char *catalog,
        const char *type);
    
    DbTable(const DbTable& from);
    
    /**
    * Destructor.
    */
    virtual ~DbTable() {}
    
    // OPERATORS    

    DbTable& operator = (const DbTable& from);

    // OPERATIONS
    // CALLBACK
    // ACCESS
    // INQUIRY
    const std::string& GetName() const { return mName; }
    const std::string& GetCompatibleName() const { return mCompatibleName; }
    const std::string& GetSchema() const { return mSchema; }
    const std::string& GetCatalog() const { return mCatalog; }
    const std::string& GetTypeName() const { return mTypeName; }
    
protected:
private:
    std::string mCompatibleName;
    std::string mName;
    std::string mSchema;
    std::string mCatalog;
    std::string mTypeName;
};

typedef std::list<DbTable> db_table_list_t;;

/* INLINE METHODS */

template <class outT>
outT& operator << (outT& o, const DbTable& v)
{
    o << v.GetCatalog() 
        << '.' << v.GetSchema() 
        << '.' << v.GetName();
    return o;
}

/* EXTERNAL REFERENCES */

END_JGAADB_NAMESPACE

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* JGAADB_DB_TABLELIST_H_ */

