/* 
    jgaadb - is a simple C++ class library for ODBC databases.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/

#include "StdAfx.h"
#include "jgaadb.h"   // class implemented

BEGIN_JGAADB_NAMESPACE

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

DbColumnDef::DbColumnDef(db_c_str_t colName, 
                         int sqlType, 
                         bool isNullable, 
                         size_t mSize, 
                         size_t mDigits) :
mName(colName ? colName : ""), mSqlType(sqlType), mIsNullable(isNullable), 
mSize(mSize), mDigits(mDigits)
{
}// DbColumnDef

DbColumnDef::DbColumnDef(const DbColumnDef& from)
{
    operator = (from);
}// DbColumnDef

DbColumnDef::~DbColumnDef()
{
}// ~DbColumnDef


//============================= OPERATORS ====================================

DbColumnDef& 
DbColumnDef::operator = (const DbColumnDef& from)
{   
    mName = from.mName;
    mSqlType = from.mSqlType;
    mIsNullable = from.mIsNullable;
    mSize = from.mSize; 
    mDigits = from.mDigits;
    mDefaultValue = from.mDefaultValue;

    return *this;
}// =

//============================= OPERATIONS ===================================
//============================= CALLBACK   ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

END_JGAADB_NAMESPACE

