/* 
    jgaadb - is a simple C++ class library for ODBC databases.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/

#include "StdAfx.h"
#include "jgaadb.h"
#include <assert.h>

BEGIN_JGAADB_NAMESPACE

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================


DbTable::DbTable(const char *name,
                 const char *schema,
                 const char *catalog,
                 const char *type) :
mName(name), mSchema(schema), mCatalog(catalog), 
mTypeName(type)
{
    mCompatibleName = get_compatible_name(name);
}

DbTable::DbTable(const DbTable& from)
{
    operator = (from);
}

//============================= OPERATORS ===================================

DbTable& DbTable::operator = (const DbTable& from)
{
    mName = from.mName;
    mCompatibleName = from.mCompatibleName;
    mSchema = from.mSchema;
    mCatalog = from.mCatalog;
    mTypeName = from.mTypeName;
    return *this;
}

//============================= OPERATIONS ===================================
//============================= CALLBACK   ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////
/////////////////////////////// PRIVATE    ///////////////////////////////////

END_JGAADB_NAMESPACE

