/* 
    jgaadb - is a simple C++ class library for ODBC databases.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/

#include "StdAfx.h"
#include "jgaadb.h"

BEGIN_JGAADB_NAMESPACE

// Create a column/table name compatible with all SQL-servers
std::string get_compatible_name(const char *name)
{
    std::string compatible_name = name;
    compatible_name.c_str();
    
    for(char *p = &compatible_name[0]; *p; p++)
    {
        if (!isalnum(*p) || (((unsigned)*p) > 127))
        {
            switch(*p)
            {
            case '\"':
                // Strip escaped names like: "name"
                if (p == &compatible_name[0])
                    compatible_name.erase(0, 1);
                else if (0 == p[1])
                    *p = 0;
                else
                    *p = '_';
                break;
            case ' ':
                *p = '_';
                break;
            case '':
                *p = 'a';
                break;
            case '':
                *p = 'a';
                break;
            case '':
                *p = 'a';
                break;
            case '':
                *p = 'a';
                break;
            case '':
                *p = 'a';
                break;
            case '':
                *p = 'a';
                break;
            case '':
                *p = 'o';
                break;
            case '':
                *p = 'O';
                break;
            case '':
                *p = 'a';
                break;
            case '':
                *p = 'a';
                break;
            case '':
                *p = 'e';
                break;
            case '':
                *p = 'E';
                break;
            case '':
                *p = 'o';
                break;
            case '':
                *p = 'O';
                break;
            default:
                *p = '_';
                break;
            }
        }
    }
    
    return compatible_name;
}

END_JGAADB_NAMESPACE